import java.awt.Button;
import java.awt.Component;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Scrollbar;
import java.awt.TextField;

class ComponentArrayList {
	private int next;
	private Component[] comps; // "austauschbares" Array

	public ComponentArrayList() {
		this.comps = new Component[4];
		this.next = 0;
	}

	public void add(Component comp) {
		this.checkIncrease();
		this.comps[this.next++] = comp;
	}

	public Component remove(int index) {
		if (index < 0 || index >= this.next) {
			return null; // ungueltig
		}
		Component result = this.comps[index];
		this.reduce(index);
		return result;
	}

	public Component get(int index) {
		if (index < 0 || index >= this.next) {
			return null; // ungueltig
		}
		return this.comps[index];
	}

	public int size() {
		return this.next;
	}

	public void createWindow() {
		Frame window = new Frame("GUI-Beispiel");

		window.setLocation(10, 20);
		window.setSize(500, 400);
		GridLayout fensterLayout = new GridLayout(this.size(), 1);
		window.setLayout(fensterLayout);

		for (int i = 0; i < this.next; i++) {
			window.add(this.comps[i]);
		}
		window.setVisible(true);
	}

	private void checkIncrease() {
		if (this.next == this.comps.length) {
			Component[] copy = new Component[this.comps.length * 2];
			for (int i = 0; i < this.comps.length; i++) {
				copy[i] = this.comps[i]; // elementweises Kopieren
			}
			this.comps = copy; // Austausch des Arrays
		}
	}

	private void reduce(int index) {
		for (int i = index; i < this.next - 1; i++) {
			this.comps[i] = this.comps[i + 1]; // nach vorne schieben
		}
		this.next--; // ein Element weniger
	}

}

public class UE17Aufgabe4 {

	public static void main(String[] args) {
		ComponentArrayList comps = new ComponentArrayList();
		comps.add(new Button("start"));
		comps.add(new Label("text"));
		comps.add(new TextField("Eingabe: "));
		comps.add(new Scrollbar());
		comps.createWindow();
		// ...
		comps.add(new Button("start2"));
		comps.add(new Label("text2"));
		comps.add(new TextField("Eingabe2: "));
		comps.createWindow();

	}

}
